\documentclass[8pt]{article}
\usepackage{amsmath}
\usepackage{amsmath}
\usepackage{amsfonts}
\numberwithin{equation}{section}
\setcounter{secnumdepth}{5}

\begin{document}
\title{Progress of the SPLSPC Toolbox}

	
\date{\today}
\author{Benoit Goepfert}

\maketitle

\section{Introduction}

Consider solving large sparse linear least squares problems :

\begin{equation}		
\min_{x \in \mathbb{R}^n} ||b-Ax||_2
\end{equation}

\noindent with $A \in \mathbb{R}^{m \times n}$, $b \in \mathbb{R}^m$ and $A$ not necessarily full rank.

\vspace{0.2cm}

\noindent In this purpose, many methods have been developed, such as direct and iterative methods.
Direct methods are often faster but for large sparse problems, iterative methods often become more efficient.
The Generalized Minimal Residual (GMRES) is an iterative method based on Krylov subspaces for solving linear systems $Ax=b$.
In order to solve underdertimed systems ($m < n$) and overdetermined systems ($m > n$), 2 algorithms hqve been derived from GMRES: AB-GMRES and BA-GMRES.

\vspace{0.2cm}

\noindent When an iterative method is used, a good preconditioner is necessary to achieve a good convergence, especially in case of ill-conditioned matrices or very large sparse matrices. This preconditioner must be unexpensive to compute and to store to be efficient.

\vspace{0.2cm}

\noindent Here we present iterative methods AB-GMRES and BA-GMRES and 3 associated preconditioners : the Robust Incomplete Factorization (RIF), the Greville's method (GREV) and the Successive Over Relaxation method with Normal Residual (NR-SOR).

\subsection{BA-GMRES}

BA-GMRES solves :
\begin{equation}		
\min_{x \in \mathbb{R}^n} ||Bb-BAx||_2
\end{equation}

\vspace{0.2cm}

\noindent where $B \in \mathbb{R}^{n \times m}$ is the preconditioning matrix.

\subsection{AB-GMRES}

AB-GMRES solves :
\begin{equation}		
\min_{u \in \mathbb{R}^m} ||b-ABu||_2
\end{equation}

\vspace{0.2cm}

\noindent where $B \in \mathbb{R}^{m \times n}$ is the preconditioning matrix.

\subsection{Robust Incomplete Factorization(RIF)}

The RIF method is a preprocessing preconditioning algorithm, which means that the preconditioner is computed before the iterative process. 
Depending on the larger dimension of the matrix $A$, this methods seeks to calculate an approximation of $A^TA$ or $AA^T$.
Indeed, it gives an upper triangular matrix $Z$ such as $A^TA$ (or $AA^T$) is almost equal to  $Z^{-T}DZ^{-1}$ with $D$ diagonal.
Thus, the preconditioner is computed in this way : if $m > n$, we have $C=ZD^{-1}Z^T$ and the preconditioner is $B=CA^T$.
Alternatively, if $m < n$, we also have $C=ZD^{-1}Z^T$ but the preconditioner is $B=A^TC$.

\subsection{Greville's method (GREV)}

The Greville's method is a preprocessing preconditioning algorithm, which means that the preconditioner is computed before the iterative process.
This methods seeks to calculate an approximation of $A^{-1}$.
Indeed, it gives an upper triangular matrix $Z$, a diagonal matrix $D$ and a matrix $V$ such as $A^{-1} \approx ZD^{-1}V$.
If $A$ is full column rank, then the implementation of the preconditioner $B$ is as follow : we have $C=ZD^{-1}Z$ and $B=CA^T$.
When $A$ is not full column rank, a switching tolerance parameter $\tau_s$ is used to detect with a chosen accuracy the linear dependency of the columns of $A$.

\subsection{Successive Over Relaxation method with Normal Residual (NRSOR)}

The SOR method is an iterative technique using an acceleration parameter used to solve a linear system of equations.
NR-SOR is a particular case of this method, where an updated residual is used for the computations.
However, on the contrary of other preconditionning methods such as Greville or RIF, the preconditioner B isn't computed before the algorithm.
Thus, in the BA-GMRES algorithm, the NR-SOR method is regulary called to roughly solve a linear system instead of using the precomputed preconditioner B.

\subsection{Existing methods to solve least square problems in Scilab}

In Scilab, several functions have already been implemented to solve sparese linear problems. The most useful is probably the backslash ("$\backslash$"), that solve linear equations but also least square problems if a non square matrix is given. This function, using a direct method, is often faster than iterative methods for many case but can sometimes be very slow or even fail to give a solution whereas it would be relatively easy with a preconditioned iterative method. Otherwise, direct method can be used with sparse matrices but only for linear systems of equations ($A$ square matrix) : LU (functions $lusolve$ and $lufact$), Quasi Minimal Resiqual method with preconditioning (function $qmr$), Generalized Minimal Residual method (function $gmres$), Cholesky Factorization (function $spchol$, $chsolve$ and $chfact$) or Preconditioned Conjugate Gradient(function $pcg$).

\section{Implementation}

\subsection{BA-GMRES}

\subsubsection{Without preconditioner}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm is coded in C++ and is based on both Dr Yin and Dr Cui's codes of this method. The default version of this algorithm is without preconditioner, so we just set $B=A^T$. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||Br_k|| < \epsilon||Br_0||$. This criterion allows us to avoid to compute $x$ at each itertation, because the value of $||Br_k||$ appears directly at the end of the Givens rotations' process. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 6 arguments in input : the matrix $A$, the vector $b$, the number of iterations before restart $restart$, the maximum total number of iterations allowed $maxiter$ and the tolerance  parameter $tol$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of iterations performed $nbiter$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise) and the cpu time for the process $itertime$.

\subsubsection{With RIF}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm with RIF preconditioner is coded in C++ and is based on Dr Yin's code. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||Br_k|| < \epsilon||Br_0||$. This criterion allows us to avoid to compute $x$ at each itertation, because the value of $||Br_k||$ appears directly at the end of the Givens rotations' process. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 7 arguments in input : the matrix $A$, the vector $b$, the drop tolerance parameter $\tau$, the number of iterations before restart $restart$, the maximum total number of iterations allowed $maxiter$ and the tolerance  parameter $tol$. As restart with this method is not adviced ,$restart$ and $maxiter$ parameters are both set to the smallest dimension of the matrix $A$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of iterations performed $nbiter$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise), the cpu time for the preconditioning process $pretime$ and the cpu time for the iterative process $itertime$. The total cpu time is so the addition of these 2 values.

\subsubsection{With GREV}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm with RIF preconditioner is coded in C++ and is based on Dr Cui's code. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||Br_k|| < \epsilon||Br_0||$. This criterion allows us to avoid to compute $x$ at each itertation, because the value of $||Br_k||$ appears directly at the end of the Givens rotations' process. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 7 arguments in input : the matrix $A$, the vector $b$, the drop tolerance parameter $\tau$, the number of iterations before restart $restart$, the maximum total number of iterations allowed $maxiter$ and the tolerance  parameter $tol$. As restart with this method is not adviced ,$restart$ and $maxiter$ parameters are both set to the smallest dimension of the matrix $A$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of iterations performed $nbiter$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise), the cpu time for the preconditioning process $pretime$ and the cpu time for the iterative process $itertime$. The total cpu time is so the addition of these 2 values.

\subsubsection{With NRSOR}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm with NRSOR preconditioner is coded in fortran and is based on Keiichi Morikuni's code. The initial vector $x_0$ is always set to $0$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||A^Tr_k|| < \epsilon||A^Tr_0||$.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 7 arguments in input : the matrix $A$, the vector $b$, the relaxation parameter $\omega$, the number of inner iterqtions $nb_{in}$, the maximum total number of iterations allowed $maxout$ and the tolerance  parameter $eps$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of outer iterations performed $nbout$, the vector of all the residuals $resid$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise) and the cpu time for the iterative process $itertime$. 

\subsection{AB-GMRES}

\subsubsection{Without preconditioner}

The AB-GMRES algorithm is coded in C++ and is based on both Dr Yin and Dr Cui's codes of this method. The default version of this algorithm is without preconditioner, so we just set $B=A^T$. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||r_k|| < \epsilon||r_0||$. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\subsubsection{With RIF}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm with RIF preconditioner is coded in C++ and is based on Dr Yin's code. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||r_k|| < \epsilon||r_0||$. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 7 arguments in input : the matrix $A$, the vector $b$, the drop tolerance parameter $\tau$, the number of iterations before restart $restart$, the maximum total number of iterations allowed $maxiter$ and the tolerance  parameter $tol$. As restart with this method is not adviced ,$restart$ and $maxiter$ parameters are both set to the smallest dimension of the matrix $A$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of iterations performed $nbiter$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise), the cpu time for the preconditioning process $pretime$ and the cpu time for the iterative process $itertime$. The total cpu time is so the addition of these 2 values.

\subsubsection{With GREV}

\paragraph{Original code}

\vspace{0.2cm}

The BA-GMRES algorithm with RIF preconditioner is coded in C++ and is based on Dr Cui's code. The initial vector $x_0$ is always set to $0$. In order to save memory, this implementation is a Restarted GMRES, i.e. restarts the algorithm with the initial vector $x_0 = x_k$ with $x_k$ current state of the solution vector $x$ at step $k$.
The algorithm breaks down after the Arnoldi's process if the value of $H(i+1,i) < 10^{-15}$, with $H$ Hessenberg matrix used in the process.
The stopping criterion used for this algorithm is $||r_k|| < \epsilon||r_0||$. It is to notice than, even after restart, $r_0=b-Ax_0=b$ is never modified during all the process.

\paragraph{Scilab}

\vspace{0.2cm}

The corresponding Scilab function created has 7 arguments in input : the matrix $A$, the vector $b$, the drop tolerance parameter $\tau$, the number of iterations before restart $restart$, the maximum total number of iterations allowed $maxiter$ and the tolerance  parameter $tol$. As restart with this method is not adviced ,$restart$ and $maxiter$ parameters are both set to the smallest dimension of the matrix $A$. In ouput, we can get a maximum of 5 parameters : the solution vector $x$, the number of iterations performed $nbiter$, a boolean for the convergence $result$ ($0$ if convergence, $1$ otherwise), the cpu time for the preconditioning process $pretime$ and the cpu time for the iterative process $itertime$. The total cpu time is so the addition of these 2 values.

\end{document}
